// AUTORI: David Pilar, Marek Vojtek


// syn.cpp: implementation of the syn class.
//
//////////////////////////////////////////////////////////////////////

#include "syn.h"

// nacte nasledujici symbol lexikalni analyzy
void syn::ctiSymbol()
{
	symbol = lexanal.ctiSoubor();
	chyba = FALSE;
}

void syn::ocekavanySymbol(int mns[], int pocet)
{
	int i;
	boolean necekany;

	necekany = TRUE;

	for (i = 0; i < pocet; i++)
	{
		if (mns[i] == symbol)
			necekany = FALSE;
	}

	if (necekany)
	{
		zobrazChybu(mns, pocet);
		while ((symbol != STREDNIK)&&(symbol != ENDOFF))
			ctiSymbol();
	}
}

void syn::zobrazChybu(int mns[], int pocet)
{
	if (!chyba)
	{
		cout << "Chyba (radek " << lexanal.vratRadek() << "): Neocekavany symbol '";
		cout << lexanal.vratNactenySymbol() << "', ocekavano " << zobrazOcekavanySymbol(mns, pocet) << endl;
		chyba = TRUE;
	}

}

char *syn::zobrazOcekavanySymbol(int mns[], int pocet)
{
	char radek[DELKA];
	int i;

	radek[0] = '\0';

	for (i = 0; i < pocet; i++)
	{
		if (mns[i] == IDINT)
			strcat (radek, "INTEGER ");
		if (mns[i] == IDREAL)
			strcat (radek, "REAL ");
		if (mns[i] == IDBOOL)
			strcat (radek, "BOOLEAN ");
		if (mns[i] == IDSTR)
			strcat (radek, "STRING ");
		if (mns[i] == INT)
			strcat (radek, "INTEGER ");
		if (mns[i] == REAL)
			strcat (radek, "REAL ");
		if (mns[i] == BOOL)
			strcat (radek, "BOOLEAN ");
		if (mns[i] == STRING)
			strcat (radek, "STRING ");
		if (mns[i] == PROM)
			strcat (radek, "PROMENNA ");
		if (mns[i] == DIM)
			strcat (radek, "DIM ");
		if (mns[i] == AS)
			strcat (radek, "AS ");
		if (mns[i] == LET)
			strcat (radek, "LET ");
		if (mns[i] == READ)
			strcat (radek, "READ ");
		if (mns[i] == WRITE)
			strcat (radek, "WRITE ");
		if (mns[i] == PLUS)
			strcat (radek, "+ ");
		if (mns[i] == MINUS)
			strcat (radek, "- ");
		if (mns[i] == KRAT)
			strcat (radek, "* ");
		if (mns[i] == DELENO)
			strcat (radek, "/ ");
		if (mns[i] == DIV)
			strcat (radek, "DIV ");
		if (mns[i] == MOD)
			strcat (radek, "MOD ");
		if (mns[i] == AND)
			strcat (radek, "AND ");
		if (mns[i] == OR)
			strcat (radek, "OR ");
		if (mns[i] == NOT)
			strcat (radek, "NOT ");
		if (mns[i] == RELOP)
			strcat (radek, "RELACNI OPERATOR ");
		if (mns[i] == CARKA)
			strcat (radek, ", ");
		if (mns[i] == STREDNIK)
			strcat (radek, "; ");
		if (mns[i] == ROVNASE)
			strcat (radek, "= ");
		if (mns[i] == LZAVORKA)
			strcat (radek, "( ");
		if (mns[i] == PZAVORKA)
			strcat (radek, ") ");
		if (mns[i] == ENDOFF)
			strcat (radek, "EOF ");
		if (mns[i] == IF)
			strcat (radek, "IF ");
		if (mns[i] == THEN)
			strcat (radek, "THEN ");
		if (mns[i] == ELSE)
			strcat (radek, "ELSE ");
		if (mns[i] == TRUNC)
			strcat (radek, "TRUNC ");
		if (mns[i] == ROUND)
			strcat (radek, "ROUND ");
		if (mns[i] == STR)
			strcat (radek, "STR ");
	}

	return radek;
}

void syn::nasledujiciSymbol(int mns[], int pocet)
{
	int i;
	boolean necekany;

	do
	{
		necekany = TRUE;

		ctiSymbol();
		for (i = 0; i < pocet; i++)
		{
			if (mns[i] == symbol)
				necekany = FALSE;
		}
		if (necekany)
		{
			zobrazChybu(mns, pocet);
			while ((symbol != STREDNIK)&&(symbol != ENDOFF))
				ctiSymbol();
		}
	} while ((necekany)&&(symbol != STREDNIK)&&(symbol != ENDOFF));

}

boolean syn::kontrolaPromenne(char jmeno[])
{
	int i;
	unsigned int j;
	char pom[DELKA], pom2[DELKA];
	boolean vrat;

	vrat = FALSE;

	strcpy (pom2, jmeno);

	for (j = 0; j < strlen(jmeno); j++)
		pom2[j] = toupper(pom2[j]);

	for (i = 0; i < pocetprom; i++)
	{
		strcpy (pom, promenne[i].hid);
		for (j = 0; j < strlen(pom); j++)
			pom[j] = toupper(pom[j]);
		if (strcmp(pom, pom2) == 0)
		{
			vrat = TRUE;
			break;
		}
	}

	return vrat;
}

int syn::vratTypPromenne(char jmeno[])
{
	int i;
	unsigned int j;
	char pom[DELKA], pom2[DELKA];

	strcpy (pom2, jmeno);

	for (j = 0; j < strlen(jmeno); j++)
		pom2[j] = toupper(pom2[j]);

	for (i = 0; i < pocetprom; i++)
	{
		strcpy (pom, promenne[i].hid);
		for (j = 0; j < strlen(pom); j++)
			pom[j] = toupper(pom[j]);
		if (strcmp(pom, pom2) == 0)
		{
			return promenne[i].typ;
		}
	}

	return 0;
}

void syn::vytvorPromennou(char jmeno[], int typ)
{
	strcpy(promenne[pocetprom].hid, jmeno);
	promenne[pocetprom].typ = typ;
	if (typ == IDINT)
		promenne[pocetprom].hint = 0;
	if (typ == IDREAL)
		promenne[pocetprom].hreal = 0;
	if (typ == IDBOOL)
		promenne[pocetprom].hbool = FALSE;
	if (typ == IDSTR)
		strcpy(promenne[pocetprom].hstring, "");

	pocetprom++;
}

void syn::zobrazChybuText(char text[])
{
	if (!chyba)
	{
		cout << "Chyba (radek " << lexanal.vratRadek() << "): " << text << endl;
		chyba = TRUE;
	}
}

void syn::ctiVstup()
{
	int i;
	unsigned int j;
	char radek[DELKA];
	boolean cislo;
	int cisloreal;

	cislo = TRUE;
	cisloreal = 0;
	
	for (i = 0; i < pocetprom; i++)
		if (strcmp (lexanal.vratNactenySymbol(), promenne[i].hid) == 0)
			break;
	cin >> radek;

	if (promenne[i].typ == IDINT)
	{
		for (j = 0; j < strlen (radek); j++)
			if (!isdigit(radek[j]))
			{
				cislo = FALSE;
				break;
			}
		if (cislo)
			promenne[i].hint = atoi (radek);
		else
		{
			cout << "Chyba (vstup): ocekavano INTEGER" << endl;
			ctiVstup();
		}
	}
	else
	if (promenne[i].typ == IDREAL)
	{
		for (j = 0; j < strlen (radek); j++)
			if ((!isdigit(radek[j]))&&(radek[j] != '.'))
			{
				cislo = FALSE;
				break;
			}
			else
				if (radek[j] == '.')
					cisloreal++;
		if ((cislo)&&((cisloreal == 1)||(cisloreal == 0)))
			promenne[i].hreal = atof(radek);
		else
		{
			cout << "Chyba (vstup): ocekavano REAL" << endl;
			ctiVstup();
		}
	}
	else
	if (promenne[i].typ == IDBOOL)
	{
		for (j = 0; j < strlen (radek); j++)
			radek[j] = toupper (radek[j]);
		if (strcmp (radek, "TRUE") == 0)
			promenne[i].hbool = TRUE;
		else
			if (strcmp (radek, "FALSE") == 0)
				promenne[i].hbool = FALSE;
			else
			{
				cout << "Chyba (vstup): ocekavano TRUE nebo FALSE" << endl;
				ctiVstup();
			}
	}
	else
	{
		strcpy (promenne[i].hstring, radek);
	}
}

void syn::nastavPromennouString(char jmeno[], char hodnota[])
{
	int i;
	unsigned int j;
	char pom[DELKA], pom2[DELKA];

	strcpy (pom2, jmeno);

	for (j = 0; j < strlen(jmeno); j++)
		pom2[j] = toupper(pom2[j]);

	for (i = 0; i < pocetprom; i++)
	{
		strcpy (pom, promenne[i].hid);
		for (j = 0; j < strlen(pom); j++)
			pom[j] = toupper(pom[j]);
		if (strcmp(pom, pom2) == 0)
		{
			strcpy (promenne[i].hstring, hodnota);
			break;
		}
	}
}


void syn::nastavPromennouInt(char jmeno[], int hodnota)
{
	int i;
	unsigned int j;
	char pom[DELKA], pom2[DELKA];

	strcpy (pom2, jmeno);

	for (j = 0; j < strlen(jmeno); j++)
		pom2[j] = toupper(pom2[j]);

	for (i = 0; i < pocetprom; i++)
	{
		strcpy (pom, promenne[i].hid);
		for (j = 0; j < strlen(pom); j++)
			pom[j] = toupper(pom[j]);
		if (strcmp(pom, pom2) == 0)
		{
			promenne[i].hint = hodnota;
			promenne[i].hreal = hodnota;
			break;
		}
	}
}

void syn::nastavPromennouReal(char jmeno[], double hodnota)
{
	int i;
	unsigned int j;
	char pom[DELKA], pom2[DELKA];

	strcpy (pom2, jmeno);

	for (j = 0; j < strlen(jmeno); j++)
		pom2[j] = toupper(pom2[j]);

	for (i = 0; i < pocetprom; i++)
	{
		strcpy (pom, promenne[i].hid);
		for (j = 0; j < strlen(pom); j++)
			pom[j] = toupper(pom[j]);
		if (strcmp(pom, pom2) == 0)
		{
			promenne[i].hreal = hodnota;
			break;
		}
	}
}

void syn::nastavPromennouBool(char jmeno[], boolean hodnota)
{
	int i;
	unsigned int j;
	char pom[DELKA], pom2[DELKA];

	strcpy (pom2, jmeno);

	for (j = 0; j < strlen(jmeno); j++)
		pom2[j] = toupper(pom2[j]);

	for (i = 0; i < pocetprom; i++)
	{
		strcpy (pom, promenne[i].hid);
		for (j = 0; j < strlen(pom); j++)
			pom[j] = toupper(pom[j]);
		if (strcmp(pom, pom2) == 0)
		{
			promenne[i].hbool = hodnota;
			break;
		}
	}
}

int syn::zaokrouhli(double cis)
{
	int cis2;
	double des;

	cis2 = int(cis);
	des = cis - cis2;
	if (des < 0)
		des = -des;
	if (des >= 0.5)
		return ((int)cis + 1);
	else
		return (int)cis;

}

// start syntakticke analyzy
void syn::start(lex l)
{
	lexanal = l;
	chyba = FALSE;
	logic = FALSE;
	pocetprom = 0;
	ctiSymbol();
	S();
}


void syn::S()
{
	int mns[MAXPOCSYM];

	mns[0] = DIM;
	mns[1] = LET;
	mns[2] = READ;
	mns[3] = WRITE;
	mns[4] = STREDNIK; // mozna tam nepatri :o)
	mns[5] = ENDOFF;
	// ocekavany symbol je DIM LET READ WRITE ; ENDOFF
	ocekavanySymbol (mns, 6);

	if (symbol != ENDOFF)
	{
		if (symbol != STREDNIK)
			P();
		if ((symbol != STREDNIK)&&(symbol != EOF))
		{
			mns[0] = STREDNIK;
			mns[1] = ENDOFF;
			nasledujiciSymbol (mns, 2);
		}
		ctiSymbol();
		S();
	}
}

void syn::P()
{
	int mns[MAXPOCSYM];

	mns[0] = DIM;
	mns[1] = LET;
	mns[2] = READ;
	mns[3] = WRITE;

	ocekavanySymbol (mns, 4);

	if (symbol == DIM)
	{
		mns[0] = PROM;
		nasledujiciSymbol (mns, 1);
		if (symbol == PROM)
		{
			strcpy (nazev, lexanal.vratNactenySymbol());
			mns[0] = AS;
			nasledujiciSymbol (mns, 1);
			if (symbol == AS)
			{
				mns[0] = IDINT;
				mns[1] = IDREAL;
				mns[2] = IDBOOL;
				mns[3] = IDSTR;
				nasledujiciSymbol (mns, 4);
				T();
			}
		}
		else
			strcpy (nazev, "");
	}
	else
	if (symbol == LET)
	{
		mns[0] = PROM;
		nasledujiciSymbol (mns, 1);
		L();
	}
	else
	if (symbol == READ)
	{
		mns[0] = PROM;
		nasledujiciSymbol (mns, 1);
		R();
	}
	else
	if (symbol == WRITE)
	{
		mns[0] = PROM;
		mns[1] = INT;
		mns[2] = REAL;
		mns[3] = BOOL;
		mns[4] = STRING;
		mns[5] = TRUNC;
		mns[6] = ROUND;
		mns[7] = IF;
		mns[8] = STR;
		mns[9] = MINUS; // mozna to tam nepatri :o)

		nasledujiciSymbol(mns, 10);
		W();
	}
}

void syn::T()
{
	int mns[MAXPOCSYM];

	mns[0] = IDINT;
	mns[1] = IDREAL;
	mns[2] = IDBOOL;
	mns[3] = IDSTR;

	ocekavanySymbol (mns, 4);

	if ((symbol == IDINT)||(symbol == IDREAL))
		T1();
	if (symbol == IDSTR)
		T2();
	if (symbol == IDBOOL)
		T3();
}

void syn::T1()
{
	int mns[MAXPOCSYM];
	char text[DELKA];

	mns[0] = IDINT;
	mns[1] = IDREAL;

	ocekavanySymbol (mns, 2);

	if ((symbol == IDINT)||(symbol == IDREAL))
	{
		if (!kontrolaPromenne(nazev))
				vytvorPromennou(nazev, symbol);
		else
		{
			strcpy (text, "promenna '");
			strcat (text, nazev);
			strcat (text, "' jiz existuje");
			zobrazChybuText(text);
		}
	}
}

void syn::T2()
{
	int mns[MAXPOCSYM];
	char text[DELKA];

	mns[0] = IDSTR;

	ocekavanySymbol (mns, 1);

	if (symbol == IDSTR)
	{
		if (!kontrolaPromenne(nazev))
				vytvorPromennou(nazev, symbol);
		else
		{
			strcpy (text, "promenna '");
			strcat (text, nazev);
			strcat (text, "' jiz existuje");
			zobrazChybuText(text);
		}
	}
}

void syn::T3()
{
	int mns[MAXPOCSYM];
	char text[DELKA];

	mns[0] = IDBOOL;

	ocekavanySymbol (mns, 1);

	if (symbol == IDBOOL)
	{
		if (!kontrolaPromenne(nazev))
				vytvorPromennou(nazev, symbol);
		else
		{
			strcpy (text, "promenna '");
			strcat (text, nazev);
			strcat (text, "' jiz existuje");
			zobrazChybuText(text);
		}
	}
}

void syn::L()
{
	int mns[MAXPOCSYM];
	char text[DELKA];
	int typ;

	mns[0] = PROM;

	ocekavanySymbol (mns, 1);

	if (symbol == PROM)
	{
		strcpy (nazev, lexanal.vratNactenySymbol());
		typ = vratTypPromenne (nazev);


		mns[0] = ROVNASE;

		nasledujiciSymbol(mns, 1);
		if (symbol == ROVNASE)
		{
			mns[0] = PROM;
			mns[1] = INT;
			mns[2] = REAL;
			mns[3] = BOOL;
			mns[4] = STRING;
			mns[5] = TRUNC;
			mns[6] = ROUND;
			mns[7] = IF;
			mns[8] = STR;
			mns[9] = MINUS;
			mns[10] = NOT;

			nasledujiciSymbol (mns, 11);

			if ((typ == IDINT)||(typ == IDREAL))
			{
				TABULKA vys;
				vys.hint = 0;
				vys.hreal = 0;
				V1(vys);
				if (vys.typ == IDINT)
					nastavPromennouInt (nazev, vys.hint);
				if (vys.typ == IDREAL)
					nastavPromennouReal (nazev, vys.hreal);
			}
			else
			if (typ == IDSTR)
			{
				strcpy (mezivysledek.hstring, "");
				V2();
				nastavPromennouString (nazev, mezivysledek.hstring);
			}
			else
			if (typ == IDBOOL)
			{
				B();
			}
			else
			{
				strcpy (text, "neznama promenna '");
				strcat (text, nazev);
				strcat (text, "'");
				zobrazChybuText (text);
			}

		}
	}
}

void syn::R()
{
	int mns[MAXPOCSYM];
	char text[DELKA];

	mns[0] = PROM;

	ocekavanySymbol (mns, 1);

	if (symbol == PROM)
	{
		if (kontrolaPromenne (lexanal.vratNactenySymbol()))
		{
			ctiVstup();
		}
		else
		{
			strcpy (text, "neznama promenna '");
			strcat (text, lexanal.vratNactenySymbol());
			strcat (text, "'");
			zobrazChybuText (text);
		}
		
		ctiSymbol(); // pokud chceme po nezname promenne ukoncit nacitani read (hodi to ale chybu),
		R1();        // tak vynecham tydle 2 radky a necham je vis (jsou jako poznamka)
	}
}

void syn::R1()
{
	int mns[MAXPOCSYM];

	mns[0] = CARKA;
	mns[1] = STREDNIK;

	ocekavanySymbol (mns, 2);

	if (symbol == CARKA)
	{
		ctiSymbol ();
		R();
	}
}

void syn::W()
{
	int mns[MAXPOCSYM];

	mns[0] = PROM;
	mns[1] = INT;
	mns[2] = REAL;
	mns[3] = BOOL;
	mns[4] = STRING;
	mns[5] = TRUNC;
	mns[6] = ROUND;
	mns[7] = IF;
	mns[8] = STR;
	mns[9] = MINUS;
	mns[10] = STREDNIK;

	ocekavanySymbol (mns, 11);

	if ((symbol == PROM)||(symbol == INT)||(symbol == REAL)||(symbol == BOOL)||\
		(symbol == STRING)||(symbol == TRUNC)||(symbol == ROUND)||(symbol == IF)||\
		(symbol == STR)||(symbol == MINUS))
	{
		V();
		W1();
	}
}

void syn::W1()
{
	int mns[MAXPOCSYM];

	mns[0] = CARKA;
	mns[1] = STREDNIK;
	mns[2] = ENDOFF;

	ocekavanySymbol (mns, 3);

	if (symbol == CARKA)
	{
		mns[0] = PROM;
		mns[1] = INT;
		mns[2] = REAL;
		mns[3] = BOOL;
		mns[4] = STRING;
		mns[5] = TRUNC;
		mns[6] = ROUND;
		mns[7] = IF;
		mns[8] = STR;
		mns[9] = MINUS;

		nasledujiciSymbol (mns, 10);
		
		W();
	}
}

void syn::V()
{
	int mns[MAXPOCSYM];
	int typ;
	int i;
	unsigned int j;
	char pom[DELKA], pom2[DELKA], text[DELKA];

	if (symbol == PROM)
	{
		strcpy (nazev, lexanal.vratNactenySymbol());

		if (kontrolaPromenne(nazev))
		{
			typ = vratTypPromenne(nazev);
			
			strcpy (pom2, nazev);

			for (j = 0; j < strlen(pom2); j++)
				pom2[j] = toupper(pom2[j]);

			for (i = 0; i < pocetprom; i++)
			{
				strcpy (pom, promenne[i].hid);
				for (j = 0; j < strlen(pom); j++)
					pom[j] = toupper(pom[j]);
				if (strcmp(pom, pom2) == 0)
				{
					break;
				}
			}
			if (typ == IDINT)
				cout << promenne[i].hint;
			if (typ == IDREAL)
				cout << promenne[i].hreal;
			if (typ == IDBOOL)
			{
				if (promenne[i].hbool)
					cout << "TRUE";
				else
					cout << "FALSE";
			}
			if (typ == IDSTR)
				cout << promenne[i].hstring;
		}
		else
		{
			strcpy (text, "neznama promenna '");
			strcat (text, nazev);
			strcat (text, "'");
			zobrazChybuText (text);
		}
	}
	else
	if (symbol == BOOL)
	{
		cout << lexanal.vratNactenySymbol();
	}
	else
	if ((symbol == STRING)||(symbol == STR))
	{
		strcpy(mezivysledek.hstring, "");
		V2();
		cout << mezivysledek.hstring;
	}
	else
	if ((symbol == INT)||(symbol == REAL)||(symbol == MINUS)||\
		(symbol == TRUNC)||(symbol == ROUND)||(symbol == IF))
	{
		TABULKA vys;
		vys.hint = 0;
		vys.hreal = 0;
		V1(vys);
		if (vys.typ == IDINT)
			cout << vys.hint;
		else
			if (vys.typ == IDREAL)
				cout << vys.hreal;
	}

	mns[0] = CARKA;
	mns[1] = STREDNIK;
	mns[2] = ENDOFF;
	
	nasledujiciSymbol (mns, 3);
}

void syn::V1(TABULKA &vys)
{
	int mns[MAXPOCSYM];

	mns[0] = PROM;
	mns[1] = INT;
	mns[2] = REAL;
	mns[3] = MINUS;
	mns[4] = TRUNC;
	mns[5] = ROUND;
	mns[6] = IF;
	mns[7] = PZAVORKA;

	ocekavanySymbol (mns, 8);
	if ((symbol == PROM)||(symbol == INT)||(symbol == REAL)||\
		(symbol == MINUS)||(symbol == TRUNC)||(symbol == ROUND)||(symbol == IF))
	{
		E1(vys);
		E2(vys);
		E3(vys);
	}

}

void syn::V2()
{
	int mns[MAXPOCSYM];

	mns[0] = PROM;
	mns[1] = STRING;
	mns[2] = STR;

	ocekavanySymbol (mns, 3);

	if ((symbol == PROM)||(symbol == STRING)||(symbol == STR))
	{
		D1();
		D2();
	}
}

void syn::D1()
{
	int mns[MAXPOCSYM];
	int i;
	unsigned int j;
	char pom[DELKA], pom2[DELKA];

	mns[0] = PROM;
	mns[1] = STRING;
	mns[2] = STR;

	ocekavanySymbol (mns, 3);

	if ((symbol == PROM)||(symbol == STRING)||(symbol == STR))
	{
		if (symbol == STRING)
			strcat (mezivysledek.hstring, lexanal.vratHodnotuString());
		else
		if (symbol == PROM)
		{
			if (vratTypPromenne(lexanal.vratNactenySymbol()) == IDSTR)
			{
				strcpy (pom2, lexanal.vratNactenySymbol());

				for (j = 0; j < strlen(pom2); j++)
					pom2[j] = toupper(pom2[j]);

				for (i = 0; i < pocetprom; i++)
				{
					strcpy (pom, promenne[i].hid);
					for (j = 0; j < strlen(pom); j++)
						pom[j] = toupper(pom[j]);
					if (strcmp(pom, pom2) == 0)
						break;
				}

				strcat (mezivysledek.hstring, promenne[i].hstring);
			}
			else
			{
				mns[0] = IDSTR;
				zobrazChybu(mns, 1);
			}
		}
		else
		if (symbol == STR)
		{
			mns[0] = LZAVORKA;

			nasledujiciSymbol(mns, 1);
			if (symbol == LZAVORKA)
			{
				TABULKA vys;
				vys.hint = 0;
				vys.hreal = 0;
				
				ctiSymbol();
				
				V1(vys);

				if ((vys.typ == IDINT)||(vys.typ == IDREAL))
				{
					mns[0] = PZAVORKA;

					ocekavanySymbol(mns, 1);
				}
				if (symbol == PZAVORKA)
				{
					if (vys.typ == IDINT)
					{
						char buffer[DELKA];

						_itoa (vys.hint, buffer, 10);

						strcat (mezivysledek.hstring, buffer);
					}
					else
						if (vys.typ == IDREAL)
						{
							int dec, sign;
							char buffer [DELKA-1], buffernew[DELKA];

							strcpy (buffer, _ecvt (vys.hreal, 20, &dec, &sign));

							for (j = 0; j < strlen (buffer); j++)
							{
								if (j < (unsigned)dec)
									buffernew[j] = buffer[j];
								else
									if (j == (unsigned)dec)
									{
										buffernew[j] = '.';
										buffernew[j+1] = buffer[j];
									}
									else
										buffernew[j+1] = buffer[j];
							}
							buffernew[j+1] = '\0';

							strcat (mezivysledek.hstring, buffernew);
						}
				}
			}
		}
	}
}

void syn::D2()
{
	int mns[MAXPOCSYM];

	mns[0] = PLUS;
	mns[1] = CARKA;
	mns[2] = STREDNIK;
	mns[3] = RELOP;
	mns[4] = ROVNASE;

	nasledujiciSymbol (mns, 5);

	if (symbol == PLUS)
	{
		ctiSymbol();
		V2();
	}
}

void syn::B()
{
	int mns[MAXPOCSYM];

	mns[0] = PROM;
	mns[1] = INT;
	mns[2] = REAL;
	mns[3] = BOOL;
	mns[4] = MINUS;
	mns[5] = TRUNC;
	mns[6] = ROUND;
	mns[7] = IF;
	mns[8] = STRING;
	mns[9] = STR;
	mns[10] = NOT;

	ocekavanySymbol(mns, 11);
	
	if ((symbol == PROM)||(symbol == INT)||(symbol == REAL)||(symbol == BOOL)||\
		(symbol == MINUS)||(symbol == TRUNC)||(symbol == ROUND)||(symbol == IF)||\
		(symbol == STRING)||(symbol == STR)||(symbol == NOT))
	{
		B1();
		B2();
		B3();

		if (vratTypPromenne(nazev) == IDBOOL)
			nastavPromennouBool(nazev, logic);
	}
}


void syn::B1()
{
	int mns[MAXPOCSYM];
	int typ;
	
	mns[0] = PROM;
	mns[1] = INT;
	mns[2] = REAL;
	mns[3] = BOOL;
	mns[4] = MINUS;
	mns[5] = TRUNC;
	mns[6] = ROUND;
	mns[7] = IF;
	mns[8] = STRING;
	mns[9] = STR;
	mns[10] = NOT;

	ocekavanySymbol(mns, 11);

	if (symbol == PROM)
	{
		typ = vratTypPromenne(lexanal.vratNactenySymbol());

		if ((typ == IDINT)||(typ == IDREAL))
		{
			TABULKA prom;
			prom.hint = 0;
			prom.hreal = 0;

			V1(prom);
			F(prom);
		}
		else
		if (typ == IDSTR)
		{
			strcpy(mezivysledek.hstring, "");
			V2();
			G();
		}
		else
		if (typ == IDBOOL)
		{
			int i;
			unsigned int j;
			char pom[DELKA], pom2[DELKA];

			strcpy (pom2, lexanal.vratNactenySymbol());

			for (j = 0; j < strlen(pom2); j++)
				pom2[j] = toupper(pom2[j]);

			for (i = 0; i < pocetprom; i++)
			{
				strcpy (pom, promenne[i].hid);
				for (j = 0; j < strlen(pom); j++)
					pom[j] = toupper(pom[j]);
				if (strcmp(pom, pom2) == 0)
					break;
			}

			logic = promenne[i].hbool;
		}
	}
	else
	if ((symbol == INT)||(symbol == REAL)||(symbol == MINUS)||(symbol == TRUNC)||\
		(symbol == ROUND)||(symbol == IF))
	{
		TABULKA prom;
		prom.hint = 0;
		prom.hreal = 0;
		V1(prom);
		F(prom);
	}
	else
	if ((symbol == STRING)||(symbol == STR))
	{
		strcpy(mezivysledek.hstring, "");
		V2();
		G();
	}
	else
	if (symbol == NOT)
	{
		ctiSymbol();
		B1();
		if (logic)
			logic = FALSE;
		else
			logic = TRUE;
	}
	else
	if (symbol == BOOL)
	{
		logic = lexanal.vratHodnotuBool();
		ctiSymbol();
	}
}

void syn::B2()
{
	int mns[MAXPOCSYM];
	boolean pom;

	mns[0] = AND;
	mns[1] = OR;
	mns[2] = STREDNIK;
	mns[3] = THEN;

	ocekavanySymbol(mns, 4);

	if (symbol == AND)
	{
		pom = logic;
		ctiSymbol();
		B1();
		B2();
		if (!pom)
			logic = pom;
	}
}

void syn::B3()
{
	int mns[MAXPOCSYM];
	boolean pom;

	mns[0] = OR;
	mns[1] = STREDNIK;
	mns[2] = THEN;

	ocekavanySymbol(mns, 3);

	if (symbol == OR)
	{
		pom = logic;
		ctiSymbol();
		B1();
		B2();
		B3();

		if (pom)
			logic = pom;
	}
}

void syn::F(TABULKA vys)
{
	int mns[MAXPOCSYM];
	TABULKA pom;
	double vysledek1, vysledek2;
	int typ;

	pom.hint = 0;
	pom.hreal = 0;

	mns[0] = RELOP;
	mns[1] = ROVNASE;

	ocekavanySymbol(mns, 2);
	lexanal.vratHodnotuRelOp();

	if ((symbol == RELOP)||(symbol == ROVNASE))
	{
		typ = symbol;

		ctiSymbol();
		V1(pom);
		if (vys.typ == IDINT)
			vysledek1 = vys.hint;
		else
			vysledek1 = vys.hreal;
		if (pom.typ == IDINT)
			vysledek2 = pom.hint;
		else
			vysledek2 = pom.hreal;

		if (lexanal.vratHodnotuRelOp() == VETSIROVNO)
		{
			if (vysledek1 >= vysledek2)
				logic = TRUE;
			else
				logic = FALSE;
		}
		if (lexanal.vratHodnotuRelOp() == VETSI)
		{
			if (vysledek1 > vysledek2)
				logic = TRUE;
			else
				logic = FALSE;
		}
		if (lexanal.vratHodnotuRelOp() == ROVNO)
		{
			if (vysledek1 = vysledek2)
				logic = TRUE;
			else
				logic = FALSE;
		}
		if (lexanal.vratHodnotuRelOp() == MENSIROVNO)
		{
			if (vysledek1 <= vysledek2)
				logic = TRUE;
			else
				logic = FALSE;
		}
		if (lexanal.vratHodnotuRelOp() == MENSI)
		{
			if (vysledek1 < vysledek2)
				logic = TRUE;
			else
				logic = FALSE;
		}
		if (lexanal.vratHodnotuRelOp() == NEROVNO)
		{
			if (vysledek1 != vysledek2)
				logic = TRUE;
			else
				logic = FALSE;
		}
	}
}

void syn::G()
{
	int mns[MAXPOCSYM];
	char pom[DELKA], pom1[DELKA];
	int typ;

	mns[0] = RELOP;
	mns[1] = ROVNASE;

	ocekavanySymbol(mns, 2);

	if ((symbol == RELOP)||(symbol == ROVNASE))
	{
		strcpy (pom, mezivysledek.hstring);
		typ = symbol;

		strcpy (mezivysledek.hstring, "");
		ctiSymbol();
		V2();
		strcpy (pom1, mezivysledek.hstring);

		if (lexanal.vratHodnotuRelOp() == VETSIROVNO)
		{
			if (strcmp(pom, pom1) >= 0)
				logic = TRUE;
			else
				logic = FALSE;
		}
		if (lexanal.vratHodnotuRelOp() == VETSI)
		{
			if (strcmp(pom, pom1) > 0)
				logic = TRUE;
			else
				logic = FALSE;
		}
		if (lexanal.vratHodnotuRelOp() == ROVNO)
		{
			if (strcmp(pom, pom1) == 0)
				logic = TRUE;
			else
				logic = FALSE;
		}
		if (lexanal.vratHodnotuRelOp() == MENSIROVNO)
		{
			if (strcmp(pom, pom1) <= 0)
				logic = TRUE;
			else
				logic = FALSE;
		}
		if (lexanal.vratHodnotuRelOp() == MENSI)
		{
			if (strcmp(pom, pom1) < 0)
				logic = TRUE;
			else
				logic = FALSE;
		}
		if (lexanal.vratHodnotuRelOp() == NEROVNO)
		{
			if (strcmp(pom, pom1) != 0)
				logic = TRUE;
			else
				logic = FALSE;
		}
	}
}

void syn::E1(TABULKA &vys)
{
	int mns[MAXPOCSYM];
	boolean minus;

	minus = FALSE;

	mns[0] = PROM;
	mns[1] = INT;
	mns[2] = REAL;
	mns[3] = MINUS;
	mns[4] = TRUNC;
	mns[5] = ROUND;
	mns[6] = IF;
	mns[7] = PZAVORKA;
	mns[8] = THEN;
	mns[9] = ELSE;
	ocekavanySymbol (mns, 10);

	if ((symbol == PROM)||(symbol == INT)||(symbol == REAL)||\
		(symbol == MINUS)||(symbol == TRUNC)||(symbol == ROUND)||(symbol == IF))
	{
		if ((symbol == PROM)||(symbol == INT)||(symbol == REAL))
		{
			N(vys, minus);

			ctiSymbol();
		}
		else
		if (symbol == MINUS)
		{
			minus = TRUE;
			
			mns[0] = PROM;
			mns[1] = INT;
			mns[2] = REAL;
			mns[3] = TRUNC;
			mns[4] = ROUND;
			mns[5] = IF;
			
			nasledujiciSymbol(mns, 6);

			N(vys, minus);
			
			ctiSymbol();
		}
		else
		if (symbol == TRUNC)
		{
			mns[0] = LZAVORKA;

			nasledujiciSymbol(mns, 1);
			if (symbol == LZAVORKA)
			{
				
				ctiSymbol();
				
				V1(vys);

				if (vys.typ == IDREAL)
				{
					mns[0] = PZAVORKA;

					ocekavanySymbol(mns, 1);
				}
				else
					zobrazChybuText("spatny typ");
				if (symbol == PZAVORKA)
				{
					if (vys.typ == IDREAL)
					{
						vys.hint = (int) vys.hreal;
						vys.typ = IDINT;
					}
				}
			}
		}
		else
		if (symbol == ROUND)
		{
			mns[0] = LZAVORKA;

			nasledujiciSymbol(mns, 1);
			if (symbol == LZAVORKA)
			{
				ctiSymbol();
				
				V1(vys);

				if (vys.typ == IDREAL)
				{
					mns[0] = PZAVORKA;
					ocekavanySymbol(mns, 1);
				}
				else
					zobrazChybuText("spatny typ");
				if (symbol == PZAVORKA)
				{
					if (vys.typ == IDREAL)
					{
						vys.hint = zaokrouhli(vys.hreal);
						vys.typ = IDINT;
					}
					else
						zobrazChybuText("spatny typ");
				}
			}
		}
		else
		if (symbol == IF)
		{
			ctiSymbol();
			B();

			mns[0] = THEN;
			ocekavanySymbol(mns, 1);

			if (symbol == THEN)
			{
				ctiSymbol();
				TABULKA pom;

				pom = vys;

				V1(pom);

				mns[0] = ELSE;
				ocekavanySymbol(mns, 1);

				if (symbol == ELSE)
				{


				ctiSymbol();
				TABULKA pom1;

				pom1 = vys;

				V1(pom1);


				if (logic)
					{
						vys = pom;
					}
					else
					{
						vys = pom1;
					}
				}
			}
		}
	}
}

void syn::N(TABULKA &vys, boolean minus)
{
	if (symbol == PROM)
	{
		if (kontrolaPromenne(lexanal.vratNactenySymbol()))
		{
			int i;
			unsigned int j;
			char pom[DELKA], pom2[DELKA];
			
			strcpy (pom2, lexanal.vratNactenySymbol());

			for (j = 0; j < strlen(pom2); j++)
				pom2[j] = toupper(pom2[j]);

			for (i = 0; i < pocetprom; i++)
			{
				strcpy (pom, promenne[i].hid);
				for (j = 0; j < strlen(pom); j++)
					pom[j] = toupper(pom[j]);
				if (strcmp(pom, pom2) == 0)
				{
					break;
				}
			}

			if (promenne[i].typ == IDINT)
			{
				if (minus)
					vys.hint = -promenne[i].hint;
				else
					vys.hint = promenne[i].hint;

				vys.typ = IDINT;
			}
			else
			if (promenne[i].typ == IDREAL)
			{
				if (minus)
					vys.hreal = -promenne[i].hreal;
				else
					vys.hreal = promenne[i].hreal;

				vys.typ = IDREAL;
			}
			else
				zobrazChybuText("spatny typ promenne");
		}
		else
			zobrazChybuText("neznama promenna");
	}
	else
	if (symbol == INT)
	{
		if (minus)
			vys.hint = -lexanal.vratHodnotuInt();
		else
			vys.hint = lexanal.vratHodnotuInt();

		vys.typ = IDINT;
	}
	else
	if (symbol == REAL)
	{
		if (minus)
			vys.hreal = -lexanal.vratHodnotuReal();
		else
			vys.hreal = lexanal.vratHodnotuReal();

		vys.typ = IDREAL;
	}
}

void syn::E2(TABULKA &vys)
{
	int mns[MAXPOCSYM];

	mns[0] = KRAT;
	mns[1] = DELENO;
	mns[2] = DIV;
	mns[3] = MOD;
	mns[4] = PLUS;
	mns[5] = MINUS;
	mns[6] = CARKA;
	mns[7] = STREDNIK;
	mns[8] = RELOP;
	mns[9] = ROVNASE;
	mns[10] = AND;
	mns[11] = OR;
	mns[12] = PZAVORKA;
	mns[13] = THEN;
	mns[14] = ELSE;
	ocekavanySymbol (mns, 15);

	if ((symbol == KRAT)||(symbol == DELENO)||(symbol == DIV)||(symbol == MOD))
	{
		if (symbol == KRAT)
		{
			mns[0] = PROM;
			mns[1] = INT;
			mns[2] = REAL;
			mns[3] = MINUS;
			mns[4] = TRUNC;
			mns[5] = ROUND;
			mns[6] = IF;
			nasledujiciSymbol(mns, 7);

			TABULKA mezi;

			mezi.hint = 0;
			mezi.hreal = 0;

			E1(mezi);

			if (mezi.typ > 0)
			{
				if ((mezi.typ == IDINT)&&(vys.typ == IDREAL))
				{
					vys.hreal = mezi.hint * vys.hreal;
					vys.typ = IDREAL;
				}
				else
				if ((mezi.typ == IDINT)&&(vys.typ == IDINT))
				{
					vys.hint = mezi.hint * vys.hint;
					vys.typ = IDINT;
				}
				else
				if ((mezi.typ == IDREAL)&&(vys.typ == IDINT))
				{
					vys.hreal = mezi.hreal * vys.hint;
					vys.typ = IDREAL;
				}
				else
				{
					vys.hreal = mezi.hreal * vys.hreal;
					vys.typ = IDREAL;
				}
			}
			else
				vys.typ = -10;

			E2(vys);
		}
		else
		if (symbol == DELENO)
		{
			mns[0] = PROM;
			mns[1] = INT;
			mns[2] = REAL;
			mns[3] = MINUS;
			mns[4] = TRUNC;
			mns[5] = ROUND;
			mns[6] = IF;
			nasledujiciSymbol(mns, 7);

			TABULKA mezi;

			mezi.hint = 0;
			mezi.hreal = 0;

			E1(mezi);

			if (mezi.typ > 0)
			{
				if ((mezi.typ == IDINT)&&(vys.typ == IDREAL))
				{
					if (mezi.hint != 0)
					{
						vys.hreal = vys.hreal / mezi.hint;
						vys.typ = IDREAL;
					}
					else
					{
						zobrazChybuText("Chyba deleni nulou.");
						vys.hreal = 0;
						vys.typ = IDREAL;
					}
				}
				else
				if ((mezi.typ == IDINT)&&(vys.typ == IDINT))
				{
					if (mezi.hint != 0)
					{
						vys.hreal =  (double) vys.hint / mezi.hint;
						vys.typ = IDREAL;
					}
					else
					{
						zobrazChybuText("Chyba deleni nulou.");
						vys.hreal = 0;
						vys.typ = IDREAL;
					}
				}
				else
				if ((mezi.typ == IDREAL)&&(vys.typ == IDINT))
				{
					if (mezi.hreal != 0)
					{
						vys.hreal = vys.hint / mezi.hreal;
						vys.typ = IDREAL;
					}
					else
					{
						zobrazChybuText("Chyba deleni nulou.");
						vys.hreal = 0;
						vys.typ = IDREAL;
					}
				}
				else
				{
					if (mezi.hreal != 0)
					{
						vys.hreal = vys.hreal / mezi.hreal;
						vys.typ = IDREAL;
					}
					else
					{
						zobrazChybuText("Chyba deleni nulou.");
						vys.hreal = 0;
						vys.typ = IDREAL;
					}
				}
			}
			else
				vys.typ = -10;

			E2(vys);
		}
		else
		if (symbol == DIV)
		{
			mns[0] = PROM;
			mns[1] = INT;
			mns[2] = MINUS;
			mns[3] = TRUNC;
			mns[4] = ROUND;
			mns[5] = IF;
			nasledujiciSymbol(mns, 6);

			TABULKA mezi;

			mezi.hint = 0;
			mezi.hreal = 0;

			E1(mezi);
			
			if (mezi.typ > 0)
			{
				if ((mezi.typ == IDINT)&&(vys.typ == IDINT))
				{
					if (mezi.hint != 0)
					{
						vys.hint =  vys.hint / mezi.hint;
						vys.typ = IDINT;
					}
					else
					{
						zobrazChybuText("Chyba deleni nulou.");
						vys.hint = 0;
						vys.typ = IDINT;
					}
				}
			}
			
			E2(vys);
		}
		else
		if (symbol == MOD)
		{
			mns[0] = PROM;
			mns[1] = INT;
			mns[2] = MINUS;
			mns[3] = TRUNC;
			mns[4] = ROUND;
			mns[5] = IF;
			nasledujiciSymbol(mns, 6);

			TABULKA mezi;

			mezi.hint = 0;
			mezi.hreal = 0;

			E1(mezi);
			
			if (mezi.typ > 0)
			{
				if ((mezi.typ == IDINT)&&(vys.typ == IDINT))
				{
					vys.hint =  vys.hint % mezi.hint;
					vys.typ = IDINT;
				}
			}
			
			E2(vys);
		}
	}
}


void syn::E3(TABULKA &vys)
{
	int mns[MAXPOCSYM];

	mns[0] = PLUS;
	mns[1] = MINUS;
	mns[2] = CARKA;
	mns[3] = STREDNIK;
	mns[4] = RELOP;
	mns[5] = ROVNASE;
	mns[6] = AND;
	mns[7] = OR;
	mns[8] = PZAVORKA;
	mns[9] = THEN;
	mns[10] = ELSE;
	ocekavanySymbol (mns, 11);

	if ((symbol == PLUS)||(symbol == MINUS))
	{
		TABULKA mezi;

		mezi.hint = 0;
		mezi.hreal = 0;

		if (symbol == PLUS)
		{
			ctiSymbol ();
			E1(mezi);
			E2(mezi);

			if (mezi.typ > 0)
			{
				if ((mezi.typ == IDINT)&&(vys.typ == IDREAL))
				{
					vys.hreal = vys.hreal + mezi.hint;
					vys.typ = IDREAL;
				}
				else
				if ((mezi.typ == IDINT)&&(vys.typ == IDINT))
				{
					vys.hint = vys.hint + mezi.hint;
					vys.typ = IDINT;
				}
				else
				if ((mezi.typ == IDREAL)&&(vys.typ == IDINT))
				{
					vys.hreal = vys.hint + mezi.hreal;
					vys.typ = IDREAL;
				}
				else
				{
					vys.hreal = vys.hreal + mezi.hreal;
					vys.typ = IDREAL;
				}
			}
			else
				vys.typ = -10;
		}
		else
		if (symbol == MINUS)
		{
			ctiSymbol ();
			E1(mezi);
			E2(mezi);

			if (mezi.typ > 0)
			{
				if ((mezi.typ == IDINT)&&(vys.typ == IDREAL))
				{
					vys.hreal = vys.hreal - mezi.hint;
					vys.typ = IDREAL;
				}
				else
				if ((mezi.typ == IDINT)&&(vys.typ == IDINT))
				{
					vys.hint = vys.hint - mezi.hint;
					vys.typ = IDINT;
				}
				else
				if ((mezi.typ == IDREAL)&&(vys.typ == IDINT))
				{
					vys.hreal = vys.hint - mezi.hreal;
					vys.typ = IDREAL;
				}
				else
				{
					vys.hreal = vys.hreal - mezi.hreal;
					vys.typ = IDREAL;
				}
			}
			else
				vys.typ = -10;
		}
	}
}
