// AUTORI: David Pilar, Marek Vojtek


// lex.h: interface for the lex class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LEX_H__D0E51268_7A06_4E55_B8B9_04BCAFC9C67D__INCLUDED_)
#define AFX_LEX_H__D0E51268_7A06_4E55_B8B9_04BCAFC9C67D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <iostream.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

#include "main.h"


class lex  
{
private:
	FILE *soubor; // vstupni soubor

	int hint; // integer-ova hodnota symbolu
	double hreal; // real-ova hodnota symbolu
	REL_OP hrelop; // typ relacniho operatoru
	char hstring[DELKA]; // string-ova hodnota symbolu
	char hid[DELKA]; // jmeno nacitaneho symbolu
	boolean hbool; // boolean-ova hodnota symbolu
	
	int radek; // aktualni radek
	int chyba; // chyba v lexikalni analyze

public:
	int nactiCislo(); // nacita cislo ze souboru a identifikuje typ cisla (real/integer)
	int nactiSlovo(); // nacte slovo ze souboru (slovo obsahuje pouze pismena a cislice, zacina pismenem)
	int vratChybu(); // vraci cislo chyby
	void nastavChybu(int hodnota); // nastavi cislo chyby (0... bez chyby)
	void nactiString(); // cte ze vstupniho souboru retezec v uvozovkach
	void nactiVetsi(); // cte ze vstupniho souboru relacni operator zacinajici na >
	void nactiMensi(); // cte ze vstupniho souboru relacni operator zacinajici na <
	int ctiSoubor(); // cte vstupni soubor
	int vratRadek(); // vraci cislo aktualniho cteneho radeku
	char *vratHodnotuString(); // vraci string hodnotu
	REL_OP vratHodnotuRelOp(); // vraci hodnotu relacniho operatoru
	double vratHodnotuReal(); // vraci realnou hodnotu
	int vratHodnotuInt(); // vraci intovou hodnotu
	boolean vratHodnotuBool(); // vraci booleanovou hodnotu
	char *vratNactenySymbol(); // vraci nacteny symbol
	void nastavRadek (int hodnota); // nastaveni hodnoty promenne radek
	boolean zavriSoubor (); // zavreni zdrojoveho souboru
	boolean otevriSoubor (char *nazev); // otevreni zdrojoveho souboru
};

#endif // !defined(AFX_LEX_H__D0E51268_7A06_4E55_B8B9_04BCAFC9C67D__INCLUDED_)
