// AUTORI: David Pilar, Marek Vojtek


// syn.h: interface for the syn class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SYN_H__CEA35C2D_3311_47A5_AF5D_37A605ED66F6__INCLUDED_)
#define AFX_SYN_H__CEA35C2D_3311_47A5_AF5D_37A605ED66F6__INCLUDED_

#include "lex.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef struct
{
	char hid[DELKA];
	int typ;
	int hint;
	double hreal;
	char hstring[DELKA];
	boolean hbool;
} TABULKA;

class syn  
{
private:
	boolean logic; // logicky mezivysledek
	TABULKA mezivysledek; // mezivysledek pri vypoctech
	int pocetprom; // pocet promennych v tabulce promennych
	TABULKA promenne[MAX]; // tabulka promennych
	lex lexanal; // lexikalni analyzator
	int symbol; // nacitany symbol
	boolean chyba; // chyba v syntakticke analyze
	char nazev[DELKA]; // nazev aktualni promenne

public:
	int zaokrouhli(double cis); // zaokrouhledni double hodnoty
	void E3(TABULKA &vys); // pravidlo E3 -> {+} E1 E2 E3 | {-} E1 E2 E3 | e
	void E2(TABULKA &vys); // pravidlo E2 -> {*} E1 E2 | {/} E1 E2 | {DIV} E1 E2 | {MOD} E1 E2 | e
	void N(TABULKA &vys, boolean minus); // pravidlo N  -> T1 | idint | idreal
	void E1(TABULKA &vys); // pravidlo E1 -> N | {-} N | {TRUNC} {(} V1 {)} | {ROUND} {(} V1 {)} | {IF} B {THEN} V1 {ELSE} V1
	void G(); // pravidlo G -> {=} V2 | {<>} V2 | {<} V2 | {>} V2 | {<=} V2 | {>=} V2
	void F(TABULKA vys); // pravidlo F -> {=} V1 | {<>} V1 | {<} V1 | {>} V1 | {<=} V1 | {>=} V1
	void B3(); // pravidlo B3 -> {OR} B1 B2 B3 | e
	void B2(); // pravidlo B2 -> {AND} B1 B2 | e
	void B1(); // pravidlo B1 -> V1 F | V2 G | {NOT} B1
	void nastavPromennouBool(char jmeno[DELKA], boolean hodnota); // nastavi hodnotu booleanove promenne
	void B(); // pravidlo B -> B1 B2 B3
	void D2(); // pravidlo D2 -> {+} V2 | e
	void D1(); // pravidlo D1 -> T2 | idstr | {STR} {(} V1 {)}
	void V2(); // pravidlo V2 -> D1 D2
	void V1(TABULKA &vys); // pravidlo V1 -> E1 E2 E3
	void nastavPromennouReal(char jmeno[DELKA], double hodnota); // nastavi hodnotu realne promenne
	void nastavPromennouInt(char jmeno [DELKA], int hodnota); // nastavi hodnotu inteagrove promenne
	void nastavPromennouString(char jmeno[DELKA], char hodnota[DELKA]); // nastavi hodnotu stingove promenne
	int vratTypPromenne(char jmeno[DELKA]); // vrati typ promenne daneho nazvu
	void ctiVstup(); // precte hodnotu z klavesnice a ulozi do prislusne promenne
	void V(); // pravidlo V -> V1 | V2
	void W1(); // pravidlo W1 -> {,} W | e
	void R1(); // pravidlo R1 -> {,} R | e
	void W(); // pravidlo W -> V W1
	void R(); // pravidlo R -> idint R1 | idreal R1 | idstr R1 | idbool R1
	void L(); // pravidlo L -> idint {=} V1 | idreal {=} V1 | idstr {=} V2 | idbool {=} B
	void zobrazChybuText (char text[DELKA]); // zobrazi chybu na obrazovku
	void vytvorPromennou(char jmeno[DELKA], int typ); // vytvori promennou v tabulce promennych
	boolean kontrolaPromenne (char jmeno[DELKA]); // kontrola promenne v tabulce promennych
	void T3(); // pravidlo T3 -> boolean
	void T2(); // pravidlo T2 -> string
	void T1(); // pravidlo T1 -> integer | real
	void T(); // pravidlo T -> T1 | T2 | T3
	void P(); // pravidlo P -> {DIM} prom {AS} T | {LET} L | {READ} R | {WRITE} W | e
	void nasledujiciSymbol(int mns[MAXPOCSYM], int pocet); // nacte nasledujici symbol (neni-li v seznamu, pak se hleda konec souboru nebo strednik)
	char *zobrazOcekavanySymbol(int mns[MAXPOCSYM], int pocet); // vypise symbol, ktery byl ocekavan
	void zobrazChybu(int mns[MAXPOCSYM], int pocet); // vypise chybu na obrazovku
	void ocekavanySymbol(int mns[MAXPOCSYM], int pocet); // kontrola nacteneho symbolu, jestli je ocekavany
	void S(); // pravidlo S -> P {;} S | e
	void ctiSymbol(); // nacte nasledujici symbol lexikalni analyzy
	void start(lex l); // start syntakticke analyzy

};

#endif // !defined(AFX_SYN_H__CEA35C2D_3311_47A5_AF5D_37A605ED66F6__INCLUDED_)
